package temp.tests;

import static org.junit.Assert.assertNotNull;

import java.io.FileNotFoundException;

import javax.inject.Inject;

import org.jboss.arquillian.container.test.api.Deployment;
import org.jboss.arquillian.junit.Arquillian;
import org.jboss.shrinkwrap.api.Archive;
import org.jboss.shrinkwrap.api.ShrinkWrap;
import org.jboss.shrinkwrap.api.spec.EnterpriseArchive;
import org.jboss.shrinkwrap.api.spec.JavaArchive;
import org.junit.Test;
import org.junit.runner.RunWith;


@RunWith(Arquillian.class)
public class TestNewService {

	protected final static String[] libraries = new String[] {
		"org.jboss.seam.persistence:seam-persistence:3.0.0.Final",
		"org.jboss.seam.solder:seam-solder:3.0.0.Final"
	};

	@Inject private MyLittleService service;

	@Deployment
	public static Archive<?> createDeployment() throws FileNotFoundException {

		EnterpriseArchive ear = ShrinkWrap.create(EnterpriseArchive.class, "main-test.ear");

		JavaArchive jar = ShrinkWrap.create(JavaArchive.class, "inner-jar.jar")
		.addClass(TestNewService.class)
		.addClass(MyLittleService.class)
		.addAsManifestResource("beans.xml");
		System.out.println( jar.toString(true) );

		ear.addAsModule(jar);
		ear.addAsModules(MavenArtifactResolver.resolve(libraries));
		ear.addAsLibraries(MavenArtifactResolver.resolve(libraries));
		
		System.out.println( ear.toString(true) );

		return ear;
	}

	@Test
	public void testServiceCreation() {
		assertNotNull(service);
		assertNotNull(service.getName());
	}
}
